﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;

namespace uterm
{
    class Program
    {
        static void Main(string[] args)
        {
            string port = "";
            int baud = 0;
            SerialPort com;

            if (args.Length < 2)
            {
                System.Console.WriteLine("Usage: uterm <port> <baud>");
                return;
            }
            try
            {
                port = args[0];
                baud = Convert.ToInt32(args[1]);
                com = new SerialPort(port, baud);
            }
            catch
            {
                System.Console.WriteLine("Port {0} BaudRate {1} Error.", port, baud);
                return;
            }
            try
            {
                com.Open();
            }
            catch
            {
                System.Console.WriteLine("Can't open {0}.", args[0]);
                return;
            }

            while (true)
            {
                while (System.Console.KeyAvailable)
                {
                    ConsoleKeyInfo key = System.Console.ReadKey();
                    char ch = key.KeyChar;
                    if (ch == 0x1b || ch == 4)
                    { // escape or control-D
                        System.Console.WriteLine("");
                        System.Console.WriteLine("All done.");
                        com.Close(); 
                        return;
                    }
                    System.Console.Write("\b");
                    com.Write(ch.ToString());
                }
                while (com.BytesToRead > 0)
                {
                    int ch = com.ReadByte();
                    char[] buff = { (char)ch, (char)0};
                    System.Console.Write(buff,0,1);
                    //if (ch == '\r') System.Console.Write("\n");
                }
            }
            com.Close();
        }
    }
}
